/*
	Cdraw.cpp
	---------
	Controls all ASCII graphics location and drawing in the game.

*/

#include <stdio.h>
#include <cstdlib> //for random stuff
#include <string.h>
#include <windows.h> //for gotoxy(int,int) function.
#include "Cdraw.h"

//using namespace std;

struct areaItems
{
	int xPos, yPos;
	//string whatSays;
	char image;
};

void draw::gotoxy(int x, int y)
{
	COORD pos;
	HANDLE screen = GetStdHandle(STD_OUTPUT_HANDLE);

	pos.X = x;
	pos.Y = y;

	SetConsoleCursorPosition(screen, pos);
}

int draw::checkCollision()
{
	if ((pX == areaEntX) && (pY == areaEntY))
		return 0;
	else if ((pX == areaExitX) && (pY == areaExitY))
		return 1;
	else if ((pX == castleX) && (pY == castleY))
		return 2;
	else if ((pX == innX) && (pY == innY))
		return 3;
	else if ((pX == wepShopX) && (pY == wepShopY))
		return 4;
	else if ((pX == magicShopX) && (pY == magicShopY))
		return 5;
	
	else
		return 99;
}

void draw::cls()
{
	//yes I'm aware that this is very repedative, but it keeps all screen functions
	//in the draw class. also LConsole is compatible w/ dos + linux.
	
	system("cls");
}

void draw::setArea(int areaNumber, int screensToNextTown)
{
	//I'm thinking an array would be a less complicated way of maping out the world.
	int i;
	areaItems villager[5]; //no need to have more than 6 villagers... EVER!!! >:0
	areaItems tree[10]; //i figured i can probably get away with going crazy w/ trees.
	
	srand((unsigned int)areaNumber); //for villagers locations+ trees
	//seeded the area number so the areas are always the same. 
	
	gotoxy(0,0);
	
	//for now every area has the same shape and look.
	printf("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++                                                                          ++\n");
	printf("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
			
	if (screensToNextTown > 0) //for "adventure" screens
	{
		for (i = 0; i < 10; i++)
		{
			tree[i].xPos = rand() % 77;
			tree[i].yPos = rand() % 21;
		}
		
		for (i = 0; i < 10; i++)
		{
			gotoxy(tree[i].xPos, tree[i].yPos);
			printf("%c\n", 5);
		}
		
		wepShop = false;
		inn = false;
		magicShop = false;
		castle = false;
			
		areaExitX = rand() % 77;
		areaExitY = rand() % 21;
			
		areaEntX = rand() % 77;
		areaEntY = rand() % 21;
		
		
	}
	
	else //in town
	{
		//setting shop locations
		wepShop = true;
		wepShopX = rand() % 77;
		wepShopY = rand() % 21;
			
		inn = true;
		innX = rand() % 77;
		innY = rand() % 21;
			
		magicShop = true;
		magicShopX = rand() % 77;
		magicShopY = rand() % 21;
			
		castle = true; //or "area's of intrest"
		castleX = rand() % 77;
		castleY = rand() % 21;
			
		areaExitX = rand() % 77;
		areaExitY = rand() % 21;
			
		areaEntX = rand() % 77;
		areaEntY = rand() % 21;

	}
	
	gotoxy(areaExitX, areaExitY);
	printf("%c\n", 176);
	
	gotoxy(areaEntX, areaEntY);
	printf("%c\n", 177);
	
	if (wepShop == true)
	{
		gotoxy(wepShopX, wepShopY);
		printf("W\n");
	}
	
	if (magicShop == true)
	{
		gotoxy(magicShopX, magicShopY);
		printf("M\n");
	}
	
	if (inn == true)
	{
		gotoxy(innX, innY);
		printf("I\n");
	}
	
	if (castle == true)
	{
		gotoxy(castleX, castleY);
		printf("C\n");
	}
}

void draw::movePlayer(int x, int y)
{
	//moves and draws player
	
	gotoxy(pX, pY); //mask the current
	printf(" \n");
	
	pX += x; //update location
	pY += y;
	
	gotoxy(pX, pY); //draw new
	printf("%c\n", 2); 
}

void draw::setPlayerPos(int x, int y) //initial location set.
{
	pX = x;
	pY = y;
}

void draw::resetPlayerPos(int resetAt) //used when changing areas in game
{
	if (resetAt == 1) // 1 = moving forward an area
	{
		//resets player to next areas entrance.
		pX = areaEntX + 1;
		pY = areaEntY;
	}
	
	else if (resetAt == 0)// 0 = moving back an area.
	{
		pX = areaExitX - 1;
		pY = areaExitY;
	}
	
	else
		printf("ERROR: Player location reset doesn't know from which direction you are coming from!!!\n");

}

void draw::playerAtLoc()
{
	gotoxy(pX, pY);
	printf("%c\n", 2);
}

bool draw::checkInBounds(int dirHeading)
{
	//checks if player is remaining in bounds of area coming from a "int" direction.
	// 0 = right
	// 1 = left
	// 2 = up
	// 3 = down
	
	switch (dirHeading)
	{
		case 0: //heading right
			if ((pX + 1) > 75)
				return false;
			else
				return true;
			break;
			
		case 1: //heading left
			if ((pX - 1) < 2)
				return false;
			else
				return true;
			break;
			
		case 2: //heading up
			if ((pY - 1) < 1)
				return false;
			else
				return true;
			break;
			
		case 3: //heading down
			if ((pY + 1) > 20)
				return false;
			else
				return true;
			break;
			
		default:
			return false;
	}
}

int draw::numAdventureScreens(int areaNumber)
{
	int numOfScreens;
	
	srand((unsigned int)areaNumber);
	numOfScreens = (rand() % 5) + 1;
	
	if (numOfScreens <= 0) //so you don't get 2 towns in a row
		numOfScreens = 1;
	
	return numOfScreens;
}

