/*
   Erik Eriksen
   ch08_ex02.cpp
   3-9-05
   
Output:
-------
How many accounts to enter (max 10)? 8


Enter your account number: 1111
Enter your service code: [R for Regular or P for Premium] R
Enter the amount of minutes used: 300


Enter your account number: 2222
Enter your service code: [R for Regular or P for Premium] p
Enter the amount of day minutes used: 150
Enter the amount of night minutes used: 200


Enter your account number: 3000
Enter your service code: [R for Regular or P for Premium] P
Enter the amount of day minutes used: 75
Enter the amount of night minutes used: 55


Enter your account number: 4000
Enter your service code: [R for Regular or P for Premium] p
Enter the amount of day minutes used: 110
Enter the amount of night minutes used: 0


Enter your account number: 5000
Enter your service code: [R for Regular or P for Premium] r
Enter the amount of minutes used: 155


Enter your account number: 7777
Enter your service code: [R for Regular or P for Premium] H
ERROR: Invalid service type!



Enter your account number: 7777
Enter your service code: [R for Regular or P for Premium] I
ERROR: Invalid service type!



Enter your account number: 7777
Enter your service code: [R for Regular or P for Premium] 3
ERROR: Invalid service type!


                                      (day/night)
Account#   Service Code    Minutes(r)  Minutes(p)    Amount Due
--------   ------------    ----------  ----------    ----------
    1111         R              300                    $60.00
    2222         p                       150/200       $37.50
    3000         P                        75/55        $25.00
    4000         p                       110/0         $28.50
    5000         r              155                    $31.00
    7777         H                         0/0         $0.00
    7777         I                         0/0         $0.00
    7777         3                         0/0         $0.00
Press any key to continue . . .
*/

#include <iostream>
#include <iomanip>

namespace cell_Phone_Rates
{
  //Regular Service Charges
  const float rServiceCharge = 10.00;
  const int   rFreeMinutes   = 50;
  const float rRateOver50    = 0.20;
  
  //Premium Service Charges
  const float pServiceCharge = 25.00;
  const int   pFreeDay       = 75;
  const float pDayRateOver75 = 0.10;
  
  const int   pFreeNight        = 100;
  const float pNightRateOver100 = 0.05;
}

using namespace cell_Phone_Rates;
using namespace std;

float regularBill(int min_Used);
float premiumBill(int m_used, int n_m_used);

int main()
{
  int accountNumber[10], minutesUsed[10], nightMinutesUsed[10], r_minutesUsed[10], i, numOfAccounts;
  char serviceCode[10];
  float totalCost[10], r_totalCost[10];
  
  //initializing all array elements
  for (i = 0; i < 10; i++)
  {
    accountNumber[i] = 0;
    minutesUsed[i] = 0;
    nightMinutesUsed[i] = 0;
    r_minutesUsed[i] = 0;
    serviceCode[i] = ' ';
    totalCost[i] = 0;
    r_totalCost[i] = 0;
  }
  
  cout << fixed << setprecision(2) << showpoint;
  
  do
  {
    cout << "How many accounts to enter (max 10)? ";
    cin >> numOfAccounts;
    if (numOfAccounts > 10 || numOfAccounts < 0)
      cout << "ERROR: Value out of range!\n\n";
      
  }while (numOfAccounts > 10 || numOfAccounts < 0);
  
 
  for (i = 0; i < numOfAccounts; i++)
  {
  
    cout << "\n\nEnter your account number: ";
    cin >> accountNumber[i];
  
    cout << "Enter your service code: [R for Regular or P for Premium] ";
    cin >> serviceCode[i];

    if (serviceCode[i] == 'r' || serviceCode[i] == 'R')
    {
       cout << "Enter the amount of minutes used: ";
       cin >> r_minutesUsed[i];
     
       r_totalCost[i] = regularBill(r_minutesUsed[i]);
    }
  
    else if (serviceCode[i] == 'P' || serviceCode[i] == 'p')
    {
      cout << "Enter the amount of day minutes used: ";
      cin >> minutesUsed[i];
    
      cout << "Enter the amount of night minutes used: ";
      cin >> nightMinutesUsed[i];
    
      totalCost[i] = premiumBill(minutesUsed[i], nightMinutesUsed[i]);
    }
  
    else
    {
      cout << "ERROR: Invalid service type!\n\n";
    
    }
  }
  
  //displaying output
  cout << "\n                                      (day/night)\n";
  cout << "Account#   Service Code    Minutes(r)  Minutes(p)    Amount Due\n";
  cout << "--------   ------------    ----------  ----------    ----------\n";
  
  for (i = 0; i < numOfAccounts; i++)
  {
    cout << setw(8) << accountNumber[i] << setw(10) << serviceCode[i]; 
    if (serviceCode[i] == 'r' || serviceCode[i] == 'R')
      cout << setw(17) << r_minutesUsed[i] << setw(20) << "$" << r_totalCost[i] << endl;
    else
      cout << setw(26) << minutesUsed[i] << "/" << nightMinutesUsed[i] << setw(10) << "$" << totalCost[i] << endl;
  }  
  
  
  system("pause");
  return 0;
}

float regularBill(int min_Used)
{
  float cost;
  int min_to_pay;
  
  min_to_pay = min_Used - rFreeMinutes;
  if (min_to_pay < 0)
    min_to_pay = 0;
    
  cost = (min_to_pay * rRateOver50) + rServiceCharge;
   
  return cost;
}

float premiumBill(int m_used, int n_m_used)
{
  float p_cost;
  int day_m_to_pay, night_m_to_pay;
  
  day_m_to_pay = m_used - pFreeDay;
  if (day_m_to_pay < 0)
    day_m_to_pay = 0;
    
  night_m_to_pay = n_m_used - pFreeNight;
  if (night_m_to_pay < 0)
    night_m_to_pay = 0;
    
  p_cost = (day_m_to_pay * pDayRateOver75) + (night_m_to_pay * pNightRateOver100) + pServiceCharge;
  
  return p_cost;
}
  