/* 
   Erik Eriksen
   5-4-05
   Ch11_ex01.cpp
   Chapter 11: Programming Exercise 1
*/

#include <iostream>
#include <string>
#include <fstream>
#include <iomanip>

using namespace std;

const int noOfStudent = 20;

struct studentType
{
  string studentFName;
  string studentLName;
  int testScore;
  char grade;
};

void getData(ifstream& inFile, studentType sList[], int listSize);
void calculateGrade(studentType sList[], int listSize);
int highestScore(const studentType sList[], int listSize);
void printResult(ofstream& outFile, const studentType sList[], int listSize);

int main()
{
  ifstream inData;
  ofstream outData;
  studentType studentList[noOfStudent];
  
  inData.open("ch11_ex01Data.txt");
  if (!inData)
  {
     cout << "The input file does not exist. Program terminates!\n";
     system("pause");
     return 1;
  }
  
  outData.open("ch11_ex01Out.txt");
  if (!outData)
  {
     cout << "Cannot open the output file. Program terminates!\n";
     system("pause");
     return 1;
  }
  
  getData(inData, studentList, noOfStudent);
  calculateGrade(studentList, noOfStudent);
  printResult(outData, studentList, noOfStudent);
  
  system("pause");

  inData.close();
  outData.close();

  return 0;
}

void getData(ifstream& inFile, studentType sList[], int listSize)
{
  for (int i = 0; i < listSize; i++)
  {
    inFile >> sList[i].studentFName;
    inFile >> sList[i].studentLName;
    inFile >> sList[i].testScore;
  }
}

void calculateGrade(studentType sList[], int listSize)
{
  for (int i = 0; i < listSize; i++)
  {
    if (sList[i].testScore >= 90)
      sList[i].grade = 'A';
    else if (sList[i].testScore >= 80)
      sList[i].grade = 'B';      
    else if (sList[i].testScore >= 70)
      sList[i].grade = 'C';
    else if (sList[i].testScore >= 65)
      sList[i].grade = 'D';
    else
      sList[i].grade = 'F';
  }
}

int highestScore(const studentType sList[], int listSize)
{
  int hScore = sList[0].testScore;
  
  for (int i = 1; i < listSize; i++)
  {
    if (sList[i].testScore > hScore)
      hScore = sList[i].testScore;
  }
  
  return hScore;
}

void printResult(ofstream& outFile, const studentType sList[], int listSize)
{
  int maxScore = highestScore(sList, listSize);
  int i;
  
  outFile << setw(15) << "Student Name         "
          << setw(10) << "Test Score"
          << setw(7)  << "  Grade\n";
  for (i = 0; i < listSize; i++)
  {
    outFile << setw(10) << sList[i].studentLName << ", " << setw(8) << sList[i].studentFName
            << setw(10) << sList[i].testScore << setw(7) << sList[i].grade << "\n";
  }
  
  outFile << "\n\nHighest Score: " << maxScore << "\n";
  for (int i = 0; i < listSize; i++)
  {
     if (sList[i].testScore == maxScore)
       outFile << sList[i].studentLName << ", " << sList[i].studentFName << "\n";
  }
}
   