//Program: Comparison of class averages.

#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>

using namespace std;

//function prototypes
void calculateAverage(ifstream& inp, float& courseAvg);
void printResult(ofstream& outp, string courseId, int groupNo, float avg);
void printHeading(ofstream& outp);

int main()
{
  string courseId1; //course id for group 1
  string courseId2; //course id for group 2
  int numberOfCourses;
  float avg1; //average for a course in group 1
  float avg2; //average for a course in group 2
  float avgGroup1; //average group 1
  float avgGroup2; //average group 2
  ifstream group1; //input stream variable for group 1
  ifstream group2; //input stream variable for group 2
  ofstream outfile; //output stream variable
  
  group1.open("group1.txt");
  group2.open("group2.txt");
  
  if (!group1 || !group2)
  {
    cout << "Unable to open the files." << endl;
    return 1;
  }
  outfile.open("student.out");
  
  outfile << fixed << showpoint;
  outfile << setprecision(2);
  
  avgGroup1 = 0.0;
  avgGroup2 = 0.0;
  
  numberOfCourses = 0;
  
  //print heading
  printHeading(outfile);
  group1 >> courseId1;
  group2 >> courseId2;
  
  while (group1 && group2)
  {
    if (courseId1 != courseId2)
    {
      cout << "Data error: Course IDs do not match." << endl;
      cout << "Program terminated." << endl;
      return 1;
    }
    
    else
    {
      calculateAverage(group1, avg1);
      calculateAverage(group2, avg2);
      printResult(outfile, courseId1, 1, avg1);
      printResult(outfile, courseId2, 2, avg2);
      avgGroup1 += avg1;
      avgGroup2 += avg2;
      outfile << endl;
      numberOfCourses++;
    }
    
    group1 >> courseId1;
    group2 >> courseId2;
  }
  
  if (group1 && !group2)
    cout << "Ran out of data for group 2 before group 1." << endl;
  else
    if (!group1 && group2)
      cout << "Ran out of data for group one before group 2." << endl;
    else
    {
      outfile << "Group 1 -- **** " << endl;
      outfile << "Group 2 -- #### " << endl;
      outfile << "Avg for group1: " << avgGroup1 / numberOfCourses <<  endl;
      outfile << "Avg for group2: " << avgGroup2 / numberOfCourses <<  endl;
    }
    
  group1.close();
  group2.close();
  outfile.close();
    
  system("pause");
  return 0;
}

void calculateAverage(ifstream& inp, float& courseAvg)
{
  float totalScore = 0.0;
  int numberOfStudents = 0;
  int score;
  
  inp >> score;
  while (score != -999)
  {
    totalScore += score;
    numberOfStudents++;
    inp >> score;
  }
  
  courseAvg = totalScore / numberOfStudents;
}

void printResult(ofstream& outp, string courseID, int groupNo, float avg)
{
  /* table output
  if (groupNo == 1)
    outp << " " << courseID << "    ";
  else 
    outp << "        ";
    
  outp << setw(8) << groupNo << setw(17) << avg << endl;
  */
  
  //bar graph output
  int noOfSymbols;
  int count;
  
  if (groupNo == 1)
    outp << setw(4) << courseID << "     ";
  else
    outp << "        ";
    
  noOfSymbols = static_cast<int>(avg) / 2;
  
  if (groupNo == 1)
    for (count = 1; count <= noOfSymbols; count++)
      outp << '*';
  else 
    for (count = 1; count <= noOfSymbols; count++)
      outp << '#';
  
  outp <<  endl;
    
}

void printHeading(ofstream& outp)
{
  outp << "Course          Course Average -9" << endl;
  outp << "  ID    0   10   20   30   40   50   60   70   80   90   100 " << endl;
  outp << "        |....|....|....|....|....|....|....|....|....|....| " << endl;
}
