/*
Erik Eriksen
paintjob.cpp
2-9-05

Output:
-------
Enter number of rooms: 3
Enter square feet of room: 180
Enter square feet of room: 144
Enter square feet of room: 300
Enter price of gallon of paint: 22.50




  Number of Gallons of paint needed: 6
           Number of Hours of labor: 5.34
                      Cost of Paint: $135.00
                      Cost of Labor: $97.67
                         Total Cost: $232.67


*/

#include <iostream>
#include <iomanip>
#include <cmath>
using namespace std;

int numRooms();
int numGals(float area);

float paintPrice();
float wallArea();
float laborHrs(float);

void displayCost(int, float, float);

int main()
{
  int numberOfRooms, galsOfPaint;
  float areaOfRooms, priceOfPaintPerGallon, priceOfPaint, hrsOfLabor;
  
  cout << setprecision(2) << fixed;
  
  numberOfRooms = numRooms();
  for (int i = 0; i < numberOfRooms; i++)
  {
    areaOfRooms += wallArea();
  }
  priceOfPaintPerGallon = paintPrice();
  galsOfPaint = numGals(areaOfRooms);
  hrsOfLabor = laborHrs(areaOfRooms);

  priceOfPaint = priceOfPaintPerGallon * galsOfPaint;
  
  displayCost(galsOfPaint, hrsOfLabor, priceOfPaint);
  
  system("pause");
  return 0;
  
}

int numRooms()
{
  int numberOfRooms = -1;
    
  while (numberOfRooms <= 0)
  {
    cout << "Enter number of rooms: ";
    cin >> numberOfRooms;

    if (numberOfRooms <= 0)
      cout << "ERROR: Number must be greater than zero.\n";
  }  
  return numberOfRooms;
}

int numGals(float area)
{
  float n_of_g;

  n_of_g = area / 115;  
  n_of_g = ceil(n_of_g);
  return n_of_g;
}

float paintPrice()
{
  float costOfPaint = -1;
  
  while (costOfPaint <= 0)
  {
    cout << "Enter price of gallon of paint: ";
    cin >> costOfPaint;

    if (costOfPaint <= 0)
      cout << "ERROR: Number must be greater than zero.\n";
  }
  return costOfPaint;
}

float wallArea()
{ 
  float areaOfWall = -1;
  
  while (areaOfWall <= 0)
  {
    cout << "Enter square feet of room: ";
    cin >> areaOfWall;

    if (areaOfWall <= 0)
      cout << "ERROR: Number must be greater than zero.\n";
  }
  return areaOfWall;
}

float laborHrs(float numberOfGallons)
{
  float hoursOfWork;
  
  hoursOfWork = numberOfGallons / 115;
  
  return hoursOfWork;
}

void displayCost(int galsOfPaint, float hoursOfLabor, float costOfPaint)
{
  float costOfLabor, totalCost;   
     
  costOfLabor = hoursOfLabor * 18.00;
  totalCost = costOfPaint + costOfLabor;

  cout << "\n\n\n\n";
  cout << " Number of Gallons of paint needed: " << galsOfPaint << endl;
  cout << "          Number of Hours of labor: " << hoursOfLabor << endl;
  cout << "                     Cost of Paint: $" << costOfPaint << endl;
  cout << "                     Cost of Labor: $" << costOfLabor << endl;
  cout << "                        Total Cost: $" << totalCost << endl << endl;
}
