/*
Erik Eriksen
payroll.cpp
2-2-05

Output:
-------

Enter employee ID: 45657
Enter number of dependents: 1
Enter hours worked: 1000
Enter rate of Pay: 8.54


      Empt ID: 45657
      Gross $: $8540.00
      Fed Tax: $1108.00
    State Tax: $170.80
     Fica Tax: $170.80
      Net Pay: $7090.40
*/

#include <iostream>
#include <iomanip>
using namespace std;

float fed_Tax(float g, int n_d);
float state_Tax(float g);
float fica_Tax(float g);
void output(int eId, float g, float fed, float state, float fica, float net);

int main()
{
  float fTax, sTax, ficaTax, hrs, rate;
  float gross, netPay, deduct;
  int empId, numDep;
  
  cout << fixed << setprecision(2);
  
  cout << "Enter employee ID: ";
  cin >> empId;
  cout << "Enter number of dependents: ";
  cin >> numDep;
  cout << "Enter hours worked: ";
  cin >> hrs;
  cout << "Enter rate of Pay: ";
  cin >> rate;
  
  gross = hrs * rate;
  
  //call function to calculate federal tax
  fTax = fed_Tax(gross, numDep);
  
  //call function to calculate state tax
  sTax = state_Tax(gross);
  
  //call function to calculate fica tax
  ficaTax = fica_Tax(gross);
  
  netPay = gross - (fTax + sTax + ficaTax);
  
  output(empId, gross, fTax, sTax, ficaTax, netPay);

  return 0;
}

float fed_Tax(float g, int n_d)
{
  float fTax, deduct;
  
  if (g < 1000)
    fTax = 0.00;
  else if (g < 2000)
    fTax = g * 0.05;
  else if (g < 3000)
    fTax = g * 0.1;
  else if (g < 4000)
    fTax = g * 0.15;
  else
    fTax = g * 0.2;
  
  //allow deduction $600 per dependent.
  deduct = n_d * 600;
  if (fTax > deduct)
    fTax -= deduct;
  else fTax = 0;
  
  return fTax;  
}

float state_Tax(float g)
{
  float sTax;
  
  if (g < 1000)
    sTax = 0.00;
  else if (g < 2000)
    sTax = g * 0.005;
  else if (g < 3000)
    sTax = g * 0.01;
  else if (g < 4000)
    sTax = g * 0.015;  
  else
    sTax = g * 0.02;
    
  return sTax;
}

float fica_Tax(float g)
{
  float ficaTax;
  
  if (g > 80000)
    ficaTax = g;
  else 
    ficaTax = 80000;
  
  ficaTax = g * 0.02;
  
  return ficaTax;
}

void output(int eId, float g, float fed, float state, float fica, float net)
{
  cout << "\n\n\t  Empt Id: " << eId << endl;
  cout << "\t  Gross $: $" << g << endl;
  cout << "\t  Fed Tax: $" << fed << endl;
  cout << "\tState Tax: $" << state << endl;
  cout << "\t Fica Tax: $" << fica << endl;
  cout << "\t  Net Pay: $" << net << endl;
} 
  
